'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _asyncGenerator2 = require('babel-runtime/helpers/asyncGenerator');

var _asyncGenerator3 = _interopRequireDefault(_asyncGenerator2);

exports.default = initGetLifecycle;

var _config = require('./config');

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initGetLifecycle(fragments, slots, loadScript, getSlotElement, options) {
  var createLifecycle = function () {
    var _ref = _asyncGenerator3.default.wrap( /*#__PURE__*/_regenerator2.default.mark(function _callee5(slotName, fragmentName, initialRender) {
      var updateStatus = function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(statusDetails) {
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return script.onUpdateStatus(statusDetails);

                case 3:
                  _context.next = 7;
                  break;

                case 5:
                  _context.prev = 5;
                  _context.t0 = _context['catch'](0);

                case 7:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 5]]);
        }));

        return function updateStatus(_x4) {
          return _ref2.apply(this, arguments);
        };
      }();

      var getElement = function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return getSlotElement(slotName, fragmentName);

                case 3:
                  return _context2.abrupt('return', _context2.sent);

                case 6:
                  _context2.prev = 6;
                  _context2.t0 = _context2['catch'](0);
                  _context2.next = 10;
                  return updateStatus((0, _config.getErrorStatusDetails)(_context2.t0));

                case 10:
                  throw _context2.t0;

                case 11:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 6]]);
        }));

        return function getElement() {
          return _ref3.apply(this, arguments);
        };
      }();

      var unmount = function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
          var unmountSlotElement, amError;
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.next = 2;
                  return getElement();

                case 2:
                  unmountSlotElement = _context3.sent;

                  if (!unmountSlotElement) {
                    _context3.next = 15;
                    break;
                  }

                  _context3.prev = 4;
                  _context3.next = 7;
                  return script.unmount(unmountSlotElement);

                case 7:
                  _context3.next = 15;
                  break;

                case 9:
                  _context3.prev = 9;
                  _context3.t0 = _context3['catch'](4);
                  amError = new _appManagerError2.default(_context3.t0, (0, _assign2.default)({}, errData, {
                    level: _constants.levels.ERROR,
                    code: 'unmount',
                    recoverable: true
                  }));
                  _context3.next = 14;
                  return updateStatus((0, _config.getErrorStatusDetails)(amError));

                case 14:
                  throw amError;

                case 15:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[4, 9]]);
        }));

        return function unmount() {
          return _ref4.apply(this, arguments);
        };
      }();

      var handleError = function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(err) {
          var slot, _errorMarkup, _errorSlotElement;

          return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.prev = 0;
                  _context4.next = 3;
                  return updateStatus((0, _config.getErrorStatusDetails)(err));

                case 3:
                  _context4.next = 5;
                  return unmount();

                case 5:
                  _context4.next = 9;
                  break;

                case 7:
                  _context4.prev = 7;
                  _context4.t0 = _context4['catch'](0);

                case 9:
                  slot = slots[slotName];

                  if (!slot) {
                    _context4.next = 22;
                    break;
                  }

                  _errorMarkup = slot.errorMarkup;

                  if (!(typeof _errorMarkup === 'string')) {
                    _context4.next = 22;
                    break;
                  }

                  _context4.prev = 13;
                  _context4.next = 16;
                  return getElement();

                case 16:
                  _errorSlotElement = _context4.sent;


                  if (_errorSlotElement) {
                    _errorSlotElement.innerHTML = _errorMarkup;
                  }
                  _context4.next = 22;
                  break;

                case 20:
                  _context4.prev = 20;
                  _context4.t1 = _context4['catch'](13);

                case 22:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, this, [[0, 7], [13, 20]]);
        }));

        return function handleError(_x5) {
          return _ref5.apply(this, arguments);
        };
      }();

      var script, _slot, errorMarkup, errorSlotElement, errData, mountSlotElement, amError, stop, _amError, slot, loadingMarkup, _errorSlotElement2;

      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              script = cachedScripts[fragmentName];

              if (script) {
                _context5.next = 17;
                break;
              }

              if (initialRender) {
                _context5.next = 16;
                break;
              }

              _slot = slots[slotName];

              if (!_slot) {
                _context5.next = 16;
                break;
              }

              errorMarkup = _slot.errorMarkup;

              if (!(typeof errorMarkup === 'string')) {
                _context5.next = 16;
                break;
              }

              _context5.prev = 7;
              _context5.next = 10;
              return _asyncGenerator3.default.await(getSlotElement(slotName, fragmentName));

            case 10:
              errorSlotElement = _context5.sent;


              if (errorSlotElement) {
                errorSlotElement.innerHTML = errorMarkup;
              }
              _context5.next = 16;
              break;

            case 14:
              _context5.prev = 14;
              _context5.t0 = _context5['catch'](7);

            case 16:
              return _context5.abrupt('return');

            case 17:
              errData = {
                source: 'lifecycle',
                fragment: fragmentName,
                slot: slotName
              };
              _context5.next = 20;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 20:
              _context5.next = 22;
              return _asyncGenerator3.default.await(getElement());

            case 22:
              mountSlotElement = _context5.sent;

              if (!mountSlotElement) {
                _context5.next = 40;
                break;
              }

              _context5.prev = 24;

              if (!initialRender) {
                _context5.next = 30;
                break;
              }

              _context5.next = 28;
              return _asyncGenerator3.default.await(script.hydrate(mountSlotElement));

            case 28:
              _context5.next = 32;
              break;

            case 30:
              _context5.next = 32;
              return _asyncGenerator3.default.await(script.render(mountSlotElement));

            case 32:
              _context5.next = 40;
              break;

            case 34:
              _context5.prev = 34;
              _context5.t1 = _context5['catch'](24);
              amError = new _appManagerError2.default(_context5.t1, (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'mount',
                recoverable: true
              }));
              _context5.next = 39;
              return _asyncGenerator3.default.await(handleError(_context5.t1));

            case 39:
              throw amError;

            case 40:
              stop = void 0;

            case 41:
              if (stop) {
                _context5.next = 80;
                break;
              }

            case 42:
              if (!true) {
                _context5.next = 56;
                break;
              }

              _context5.prev = 43;
              _context5.next = 46;
              return;

            case 46:
              stop = _context5.sent;
              return _context5.abrupt('break', 56);

            case 50:
              _context5.prev = 50;
              _context5.t2 = _context5['catch'](43);
              _context5.next = 54;
              return _asyncGenerator3.default.await(updateStatus((0, _config.getErrorStatusDetails)(_context5.t2)));

            case 54:
              _context5.next = 42;
              break;

            case 56:
              _context5.next = 58;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 58:
              _context5.next = 60;
              return;

            case 60:
              stop = _context5.sent;
              _context5.next = 63;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 63:
              _context5.next = 65;
              return;

            case 65:
              stop = _context5.sent;

              if (stop) {
                _context5.next = 78;
                break;
              }

              _context5.prev = 67;
              _context5.next = 70;
              return _asyncGenerator3.default.await(script.onStateChange());

            case 70:
              _context5.next = 78;
              break;

            case 72:
              _context5.prev = 72;
              _context5.t3 = _context5['catch'](67);
              _amError = new _appManagerError2.default(_context5.t3, (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'on_state_change',
                recoverable: true
              }));
              _context5.next = 77;
              return _asyncGenerator3.default.await(handleError(_context5.t3));

            case 77:
              throw _amError;

            case 78:
              _context5.next = 41;
              break;

            case 80:
              _context5.next = 82;
              return _asyncGenerator3.default.await(unmount());

            case 82:
              slot = slots[slotName];

              if (!slot) {
                _context5.next = 95;
                break;
              }

              loadingMarkup = slot.loadingMarkup;

              if (!(typeof loadingMarkup === 'string')) {
                _context5.next = 95;
                break;
              }

              _context5.prev = 86;
              _context5.next = 89;
              return _asyncGenerator3.default.await(getElement());

            case 89:
              _errorSlotElement2 = _context5.sent;


              if (_errorSlotElement2) {
                _errorSlotElement2.innerHTML = loadingMarkup;
              }
              _context5.next = 95;
              break;

            case 93:
              _context5.prev = 93;
              _context5.t4 = _context5['catch'](86);

            case 95:
              _context5.next = 97;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 97:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this, [[7, 14], [24, 34], [43, 50], [67, 72], [86, 93]]);
    }));

    return function createLifecycle(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  var handleLifecycleError = function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(slotName, err) {
      var errorPromises;
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              if (mountedLifecycles[slotName]) {
                delete mountedLifecycles[slotName];
              }

              errorPromises = function errorPromises() {
                return (0, _keys2.default)(mountedLifecycles).map(function (errorSlot) {
                  return mountedLifecycles[errorSlot].throw(err);
                });
              };

              _context6.next = 4;
              return _promise2.default.all(errorPromises());

            case 4:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    return function handleLifecycleError(_x6, _x7) {
      return _ref6.apply(this, arguments);
    };
  }();

  var updateAllSlots = function () {
    var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
      var updateAllSlotsPromises;
      return _regenerator2.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              updateAllSlotsPromises = function updateAllSlotsPromises() {
                return (0, _keys2.default)(mountedLifecycles).map(function (statusSlot) {
                  return mountedLifecycles[statusSlot].next(false);
                });
              };

              _context7.next = 3;
              return _promise2.default.all(updateAllSlotsPromises());

            case 3:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    return function updateAllSlots() {
      return _ref7.apply(this, arguments);
    };
  }();

  var mountedLifecycles = {};
  var cachedScripts = {};

  var loadingStatusDetails = (0, _config.getLoadingStatusDetails)();
  var defaultStatusDetails = (0, _config.getDefaultStatusDetails)();

  return function () {
    var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(pageDiff, initialRender) {
      var _this = this;

      var unmount, mount, update, onError, slotsToUpdate, slotsToUnmount, slotsToMount, loadScriptPromises, updatePromises, unmountPromises, mountPromises, haveScripts;
      return _regenerator2.default.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              unmount = pageDiff.unmount, mount = pageDiff.mount, update = pageDiff.update;
              onError = typeof options.onError === 'function' ? options.onError : function (_err) {};
              slotsToUpdate = (0, _keys2.default)(update);
              slotsToUnmount = (0, _keys2.default)(unmount);
              slotsToMount = (0, _keys2.default)(mount);

              loadScriptPromises = function loadScriptPromises() {
                return slotsToMount.map(function () {
                  var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(slotName) {
                    var fragmentName, _script;

                    return _regenerator2.default.wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            fragmentName = mount[slotName];

                            if (!cachedScripts[fragmentName]) {
                              _context8.next = 3;
                              break;
                            }

                            return _context8.abrupt('return', true);

                          case 3:
                            _context8.prev = 3;
                            _context8.next = 6;
                            return loadScript(slotName, fragmentName);

                          case 6:
                            _script = _context8.sent;

                            if (_script) {
                              _context8.next = 9;
                              break;
                            }

                            return _context8.abrupt('return', false);

                          case 9:

                            cachedScripts[fragmentName] = _script;
                            return _context8.abrupt('return', true);

                          case 13:
                            _context8.prev = 13;
                            _context8.t0 = _context8['catch'](3);
                            _context8.next = 17;
                            return handleLifecycleError(slotName, _context8.t0);

                          case 17:
                            onError(_context8.t0);
                            return _context8.abrupt('return', false);

                          case 19:
                          case 'end':
                            return _context8.stop();
                        }
                      }
                    }, _callee8, _this, [[3, 13]]);
                  }));

                  return function (_x10) {
                    return _ref9.apply(this, arguments);
                  };
                }());
              };

              updatePromises = function updatePromises() {
                return slotsToUpdate.map(function () {
                  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(slotName) {
                    return _regenerator2.default.wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            _context9.prev = 0;

                            if (!mountedLifecycles[slotName]) {
                              _context9.next = 4;
                              break;
                            }

                            _context9.next = 4;
                            return mountedLifecycles[slotName].next(false);

                          case 4:
                            _context9.next = 11;
                            break;

                          case 6:
                            _context9.prev = 6;
                            _context9.t0 = _context9['catch'](0);
                            _context9.next = 10;
                            return handleLifecycleError(slotName, _context9.t0);

                          case 10:
                            onError(_context9.t0);

                          case 11:
                          case 'end':
                            return _context9.stop();
                        }
                      }
                    }, _callee9, _this, [[0, 6]]);
                  }));

                  return function (_x11) {
                    return _ref10.apply(this, arguments);
                  };
                }());
              };

              unmountPromises = function unmountPromises() {
                return slotsToUnmount.map(function () {
                  var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(slotName) {
                    return _regenerator2.default.wrap(function _callee10$(_context10) {
                      while (1) {
                        switch (_context10.prev = _context10.next) {
                          case 0:
                            _context10.prev = 0;

                            if (!mountedLifecycles[slotName]) {
                              _context10.next = 5;
                              break;
                            }

                            _context10.next = 4;
                            return mountedLifecycles[slotName].next(true);

                          case 4:
                            delete mountedLifecycles[slotName];

                          case 5:
                            _context10.next = 12;
                            break;

                          case 7:
                            _context10.prev = 7;
                            _context10.t0 = _context10['catch'](0);
                            _context10.next = 11;
                            return handleLifecycleError(slotName, _context10.t0);

                          case 11:
                            onError(_context10.t0);

                          case 12:
                          case 'end':
                            return _context10.stop();
                        }
                      }
                    }, _callee10, _this, [[0, 7]]);
                  }));

                  return function (_x12) {
                    return _ref11.apply(this, arguments);
                  };
                }());
              };

              mountPromises = function mountPromises() {
                return slotsToMount.map(function () {
                  var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(slotName) {
                    var fragmentName;
                    return _regenerator2.default.wrap(function _callee11$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            fragmentName = mount[slotName];
                            _context11.prev = 1;

                            if (!mountedLifecycles[slotName]) {
                              _context11.next = 4;
                              break;
                            }

                            throw new _appManagerError2.default('Overwriting an existing fragment.', {
                              source: 'update_page',
                              fragment: fragmentName,
                              slot: slotName,
                              level: _constants.levels.ERROR,
                              code: 'overwrite_existing',
                              recoverable: true
                            });

                          case 4:
                            _context11.next = 6;
                            return createLifecycle(slotName, fragmentName, initialRender);

                          case 6:
                            mountedLifecycles[slotName] = _context11.sent;
                            _context11.next = 9;
                            return mountedLifecycles[slotName].next(false);

                          case 9:
                            _context11.next = 16;
                            break;

                          case 11:
                            _context11.prev = 11;
                            _context11.t0 = _context11['catch'](1);
                            _context11.next = 15;
                            return handleLifecycleError(slotName, _context11.t0);

                          case 15:
                            onError(_context11.t0);

                          case 16:
                          case 'end':
                            return _context11.stop();
                        }
                      }
                    }, _callee11, _this, [[1, 11]]);
                  }));

                  return function (_x13) {
                    return _ref12.apply(this, arguments);
                  };
                }());
              };

              _context12.next = 11;
              return updateAllSlots();

            case 11:
              _context12.next = 13;
              return _promise2.default.all(updatePromises());

            case 13:
              _context12.next = 15;
              return _promise2.default.all(unmountPromises());

            case 15:
              _context12.next = 17;
              return _promise2.default.all(loadScriptPromises());

            case 17:
              haveScripts = _context12.sent;
              _context12.next = 20;
              return _promise2.default.all(mountPromises());

            case 20:
              _context12.next = 22;
              return updateAllSlots();

            case 22:
              return _context12.abrupt('return', haveScripts.every(Boolean));

            case 23:
            case 'end':
              return _context12.stop();
          }
        }
      }, _callee12, this);
    }));

    function updatePage(_x8, _x9) {
      return _ref8.apply(this, arguments);
    }

    return updatePage;
  }();
}