'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = initScriptFunctions;

var _config = require('./config');

var _constants = require('../constants');

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initScriptFunctions(w, fragments, options, getState) {
  function wrapScript(script) {
    return {
      hydrate: function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotElement) {
          var state;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  state = getState();
                  _context.t0 = script.version;
                  _context.next = _context.t0 === 3 ? 4 : _context.t0 === 4 ? 8 : _context.t0 === 5 ? 17 : 27;
                  break;

                case 4:
                  if (!(state && state.app)) {
                    _context.next = 7;
                    break;
                  }

                  _context.next = 7;
                  return script.hydrate(slotElement, w.history, state.app);

                case 7:
                  return _context.abrupt('break', 28);

                case 8:
                  if (!state) {
                    _context.next = 16;
                    break;
                  }

                  if (!(typeof script.hydrate === 'function')) {
                    _context.next = 14;
                    break;
                  }

                  _context.next = 12;
                  return script.hydrate(slotElement, state.app);

                case 12:
                  _context.next = 16;
                  break;

                case 14:
                  _context.next = 16;
                  return script.mount(slotElement, _constants.eventTitles.HISTORY_REPLACE_STATE, state.app);

                case 16:
                  return _context.abrupt('break', 28);

                case 17:
                  if (!state) {
                    _context.next = 26;
                    break;
                  }

                  if (!(typeof script.hydrate === 'function')) {
                    _context.next = 23;
                    break;
                  }

                  _context.next = 21;
                  return script.hydrate(slotElement, state);

                case 21:
                  _context.next = 26;
                  break;

                case 23:
                  if (!(typeof script.render === 'function')) {
                    _context.next = 26;
                    break;
                  }

                  _context.next = 26;
                  return script.render(slotElement, state);

                case 26:
                  return _context.abrupt('break', 28);

                case 27:
                  throw new Error('Script has invalid version.');

                case 28:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function hydrate(_x) {
          return _ref.apply(this, arguments);
        }

        return hydrate;
      }(),
      render: function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(slotElement) {
          var state;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  state = getState();
                  _context2.t0 = script.version;
                  _context2.next = _context2.t0 === 3 ? 4 : _context2.t0 === 4 ? 8 : _context2.t0 === 5 ? 12 : 16;
                  break;

                case 4:
                  if (!state) {
                    _context2.next = 7;
                    break;
                  }

                  _context2.next = 7;
                  return script.mount(slotElement, w.history, state.app);

                case 7:
                  return _context2.abrupt('break', 17);

                case 8:
                  if (!(state && state.event)) {
                    _context2.next = 11;
                    break;
                  }

                  _context2.next = 11;
                  return script.mount(slotElement, state.event, state.app);

                case 11:
                  return _context2.abrupt('break', 17);

                case 12:
                  if (!(state && typeof script.render === 'function')) {
                    _context2.next = 15;
                    break;
                  }

                  _context2.next = 15;
                  return script.render(slotElement, state);

                case 15:
                  return _context2.abrupt('break', 17);

                case 16:
                  throw new Error('Script has invalid version.');

                case 17:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function render(_x2) {
          return _ref2.apply(this, arguments);
        }

        return render;
      }(),
      onStateChange: function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
          var state;
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  state = getState();
                  _context3.t0 = script.version;
                  _context3.next = _context3.t0 === 3 ? 4 : _context3.t0 === 4 ? 8 : _context3.t0 === 5 ? 13 : 17;
                  break;

                case 4:
                  if (!state) {
                    _context3.next = 7;
                    break;
                  }

                  _context3.next = 7;
                  return script.onStateChange(w.history, state.app);

                case 7:
                  return _context3.abrupt('break', 18);

                case 8:
                  if (!(state && typeof script.onStateChange === 'function')) {
                    _context3.next = 12;
                    break;
                  }

                  if (!state.event) {
                    _context3.next = 12;
                    break;
                  }

                  _context3.next = 12;
                  return script.onStateChange(state.event, state.app);

                case 12:
                  return _context3.abrupt('break', 18);

                case 13:
                  if (!(state && typeof script.onStateChange === 'function')) {
                    _context3.next = 16;
                    break;
                  }

                  _context3.next = 16;
                  return script.onStateChange(state);

                case 16:
                  return _context3.abrupt('break', 18);

                case 17:
                  throw new Error('Script has invalid version.');

                case 18:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function onStateChange() {
          return _ref3.apply(this, arguments);
        }

        return onStateChange;
      }(),
      unmount: function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(slotElement) {
          var state;
          return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  state = getState();
                  _context4.t0 = script.version;
                  _context4.next = _context4.t0 === 3 ? 4 : _context4.t0 === 4 ? 8 : _context4.t0 === 5 ? 12 : 16;
                  break;

                case 4:
                  if (!(state && state.prevApp)) {
                    _context4.next = 7;
                    break;
                  }

                  _context4.next = 7;
                  return script.unmount(slotElement, w.history, state.prevApp);

                case 7:
                  return _context4.abrupt('break', 17);

                case 8:
                  if (!(state && state.event && state.prevApp)) {
                    _context4.next = 11;
                    break;
                  }

                  _context4.next = 11;
                  return script.unmount(slotElement, state.event, state.prevApp);

                case 11:
                  return _context4.abrupt('break', 17);

                case 12:
                  if (!(state && typeof script.unmount === 'function')) {
                    _context4.next = 15;
                    break;
                  }

                  _context4.next = 15;
                  return script.unmount(slotElement, state);

                case 15:
                  return _context4.abrupt('break', 17);

                case 16:
                  throw new Error('Script has invalid version.');

                case 17:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function unmount(_x3) {
          return _ref4.apply(this, arguments);
        }

        return unmount;
      }(),
      onUpdateStatus: function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(statusDetails) {
          var state;
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  state = getState();
                  _context5.t0 = script.version;
                  _context5.next = _context5.t0 === 3 ? 4 : _context5.t0 === 4 ? 5 : _context5.t0 === 5 ? 9 : 13;
                  break;

                case 4:
                  return _context5.abrupt('break', 14);

                case 5:
                  if (!(state && typeof script.onUpdateStatus === 'function')) {
                    _context5.next = 8;
                    break;
                  }

                  _context5.next = 8;
                  return script.onUpdateStatus(statusDetails.status, state.app);

                case 8:
                  return _context5.abrupt('break', 14);

                case 9:
                  if (!(state && typeof script.onUpdateStatus === 'function')) {
                    _context5.next = 12;
                    break;
                  }

                  _context5.next = 12;
                  return script.onUpdateStatus(statusDetails, state);

                case 12:
                  return _context5.abrupt('break', 14);

                case 13:
                  throw new Error('Script has invalid version.');

                case 14:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, this);
        }));

        function onUpdateStatus(_x4) {
          return _ref5.apply(this, arguments);
        }

        return onUpdateStatus;
      }()
    };
  }

  return function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(slotName, fragmentName) {
      var errData, fragment, state, script;
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              errData = {
                source: 'load_script',
                fragment: fragmentName,
                slot: slotName
              };
              fragment = fragments[fragmentName];

              if (fragment) {
                _context6.next = 4;
                break;
              }

              throw new _appManagerError2.default('Fragment ' + fragmentName + ' could not be found', (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'missing_fragment',
                recoverable: true
              }));

            case 4:
              state = getState();

              if (!(typeof fragment.loadScript !== 'function' || !state)) {
                _context6.next = 7;
                break;
              }

              return _context6.abrupt('return', null);

            case 7:
              script = void 0;
              _context6.prev = 8;
              _context6.next = 11;
              return _promise2.default.race([fragment.loadScript(state), (0, _config.delay)(options.importTimeout)]);

            case 11:
              script = _context6.sent;
              _context6.next = 17;
              break;

            case 14:
              _context6.prev = 14;
              _context6.t0 = _context6['catch'](8);
              throw new _appManagerError2.default(_context6.t0, (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'load_script',
                recoverable: true
              }));

            case 17:
              if (script) {
                _context6.next = 19;
                break;
              }

              throw new _appManagerError2.default('loadScript timed out for fragment ' + fragmentName + '.', (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'time_out',
                recoverable: true
              }));

            case 19:
              return _context6.abrupt('return', wrapScript(script));

            case 20:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this, [[8, 14]]);
    }));

    function loadScript(_x5, _x6) {
      return _ref6.apply(this, arguments);
    }

    return loadScript;
  }();
}